// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kuka_driver_interfaces:msg/FriConfiguration.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__TRAITS_HPP_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kuka_driver_interfaces/msg/detail/fri_configuration__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kuka_driver_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FriConfiguration & msg,
  std::ostream & out)
{
  out << "{";
  // member: receive_multiplier
  {
    out << "receive_multiplier: ";
    rosidl_generator_traits::value_to_yaml(msg.receive_multiplier, out);
    out << ", ";
  }

  // member: send_period_ms
  {
    out << "send_period_ms: ";
    rosidl_generator_traits::value_to_yaml(msg.send_period_ms, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FriConfiguration & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: receive_multiplier
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "receive_multiplier: ";
    rosidl_generator_traits::value_to_yaml(msg.receive_multiplier, out);
    out << "\n";
  }

  // member: send_period_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "send_period_ms: ";
    rosidl_generator_traits::value_to_yaml(msg.send_period_ms, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FriConfiguration & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kuka_driver_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kuka_driver_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kuka_driver_interfaces::msg::FriConfiguration & msg,
  std::ostream & out, size_t indentation = 0)
{
  kuka_driver_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kuka_driver_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kuka_driver_interfaces::msg::FriConfiguration & msg)
{
  return kuka_driver_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kuka_driver_interfaces::msg::FriConfiguration>()
{
  return "kuka_driver_interfaces::msg::FriConfiguration";
}

template<>
inline const char * name<kuka_driver_interfaces::msg::FriConfiguration>()
{
  return "kuka_driver_interfaces/msg/FriConfiguration";
}

template<>
struct has_fixed_size<kuka_driver_interfaces::msg::FriConfiguration>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kuka_driver_interfaces::msg::FriConfiguration>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kuka_driver_interfaces::msg::FriConfiguration>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__TRAITS_HPP_
