// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__BUILDER_HPP_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kuka_driver_interfaces/msg/detail/fri_state__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kuka_driver_interfaces
{

namespace msg
{

namespace builder
{

class Init_FRIState_tracking_performance
{
public:
  explicit Init_FRIState_tracking_performance(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  ::kuka_driver_interfaces::msg::FRIState tracking_performance(::kuka_driver_interfaces::msg::FRIState::_tracking_performance_type arg)
  {
    msg_.tracking_performance = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_overlay_type
{
public:
  explicit Init_FRIState_overlay_type(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_tracking_performance overlay_type(::kuka_driver_interfaces::msg::FRIState::_overlay_type_type arg)
  {
    msg_.overlay_type = std::move(arg);
    return Init_FRIState_tracking_performance(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_drive_state
{
public:
  explicit Init_FRIState_drive_state(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_overlay_type drive_state(::kuka_driver_interfaces::msg::FRIState::_drive_state_type arg)
  {
    msg_.drive_state = std::move(arg);
    return Init_FRIState_overlay_type(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_operation_mode
{
public:
  explicit Init_FRIState_operation_mode(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_drive_state operation_mode(::kuka_driver_interfaces::msg::FRIState::_operation_mode_type arg)
  {
    msg_.operation_mode = std::move(arg);
    return Init_FRIState_drive_state(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_control_mode
{
public:
  explicit Init_FRIState_control_mode(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_operation_mode control_mode(::kuka_driver_interfaces::msg::FRIState::_control_mode_type arg)
  {
    msg_.control_mode = std::move(arg);
    return Init_FRIState_operation_mode(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_command_mode
{
public:
  explicit Init_FRIState_command_mode(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_control_mode command_mode(::kuka_driver_interfaces::msg::FRIState::_command_mode_type arg)
  {
    msg_.command_mode = std::move(arg);
    return Init_FRIState_control_mode(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_safety_state
{
public:
  explicit Init_FRIState_safety_state(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_command_mode safety_state(::kuka_driver_interfaces::msg::FRIState::_safety_state_type arg)
  {
    msg_.safety_state = std::move(arg);
    return Init_FRIState_command_mode(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_connection_quality
{
public:
  explicit Init_FRIState_connection_quality(::kuka_driver_interfaces::msg::FRIState & msg)
  : msg_(msg)
  {}
  Init_FRIState_safety_state connection_quality(::kuka_driver_interfaces::msg::FRIState::_connection_quality_type arg)
  {
    msg_.connection_quality = std::move(arg);
    return Init_FRIState_safety_state(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

class Init_FRIState_session_state
{
public:
  Init_FRIState_session_state()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_FRIState_connection_quality session_state(::kuka_driver_interfaces::msg::FRIState::_session_state_type arg)
  {
    msg_.session_state = std::move(arg);
    return Init_FRIState_connection_quality(msg_);
  }

private:
  ::kuka_driver_interfaces::msg::FRIState msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::kuka_driver_interfaces::msg::FRIState>()
{
  return kuka_driver_interfaces::msg::builder::Init_FRIState_session_state();
}

}  // namespace kuka_driver_interfaces

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__BUILDER_HPP_
