// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice
#include "kuka_driver_interfaces/msg/detail/fri_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
kuka_driver_interfaces__msg__FRIState__init(kuka_driver_interfaces__msg__FRIState * msg)
{
  if (!msg) {
    return false;
  }
  // session_state
  // connection_quality
  // safety_state
  // command_mode
  // control_mode
  // operation_mode
  // drive_state
  // overlay_type
  // tracking_performance
  return true;
}

void
kuka_driver_interfaces__msg__FRIState__fini(kuka_driver_interfaces__msg__FRIState * msg)
{
  if (!msg) {
    return;
  }
  // session_state
  // connection_quality
  // safety_state
  // command_mode
  // control_mode
  // operation_mode
  // drive_state
  // overlay_type
  // tracking_performance
}

bool
kuka_driver_interfaces__msg__FRIState__are_equal(const kuka_driver_interfaces__msg__FRIState * lhs, const kuka_driver_interfaces__msg__FRIState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // session_state
  if (lhs->session_state != rhs->session_state) {
    return false;
  }
  // connection_quality
  if (lhs->connection_quality != rhs->connection_quality) {
    return false;
  }
  // safety_state
  if (lhs->safety_state != rhs->safety_state) {
    return false;
  }
  // command_mode
  if (lhs->command_mode != rhs->command_mode) {
    return false;
  }
  // control_mode
  if (lhs->control_mode != rhs->control_mode) {
    return false;
  }
  // operation_mode
  if (lhs->operation_mode != rhs->operation_mode) {
    return false;
  }
  // drive_state
  if (lhs->drive_state != rhs->drive_state) {
    return false;
  }
  // overlay_type
  if (lhs->overlay_type != rhs->overlay_type) {
    return false;
  }
  // tracking_performance
  if (lhs->tracking_performance != rhs->tracking_performance) {
    return false;
  }
  return true;
}

bool
kuka_driver_interfaces__msg__FRIState__copy(
  const kuka_driver_interfaces__msg__FRIState * input,
  kuka_driver_interfaces__msg__FRIState * output)
{
  if (!input || !output) {
    return false;
  }
  // session_state
  output->session_state = input->session_state;
  // connection_quality
  output->connection_quality = input->connection_quality;
  // safety_state
  output->safety_state = input->safety_state;
  // command_mode
  output->command_mode = input->command_mode;
  // control_mode
  output->control_mode = input->control_mode;
  // operation_mode
  output->operation_mode = input->operation_mode;
  // drive_state
  output->drive_state = input->drive_state;
  // overlay_type
  output->overlay_type = input->overlay_type;
  // tracking_performance
  output->tracking_performance = input->tracking_performance;
  return true;
}

kuka_driver_interfaces__msg__FRIState *
kuka_driver_interfaces__msg__FRIState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FRIState * msg = (kuka_driver_interfaces__msg__FRIState *)allocator.allocate(sizeof(kuka_driver_interfaces__msg__FRIState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kuka_driver_interfaces__msg__FRIState));
  bool success = kuka_driver_interfaces__msg__FRIState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kuka_driver_interfaces__msg__FRIState__destroy(kuka_driver_interfaces__msg__FRIState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kuka_driver_interfaces__msg__FRIState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kuka_driver_interfaces__msg__FRIState__Sequence__init(kuka_driver_interfaces__msg__FRIState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FRIState * data = NULL;

  if (size) {
    data = (kuka_driver_interfaces__msg__FRIState *)allocator.zero_allocate(size, sizeof(kuka_driver_interfaces__msg__FRIState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kuka_driver_interfaces__msg__FRIState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kuka_driver_interfaces__msg__FRIState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kuka_driver_interfaces__msg__FRIState__Sequence__fini(kuka_driver_interfaces__msg__FRIState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kuka_driver_interfaces__msg__FRIState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kuka_driver_interfaces__msg__FRIState__Sequence *
kuka_driver_interfaces__msg__FRIState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FRIState__Sequence * array = (kuka_driver_interfaces__msg__FRIState__Sequence *)allocator.allocate(sizeof(kuka_driver_interfaces__msg__FRIState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kuka_driver_interfaces__msg__FRIState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kuka_driver_interfaces__msg__FRIState__Sequence__destroy(kuka_driver_interfaces__msg__FRIState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kuka_driver_interfaces__msg__FRIState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kuka_driver_interfaces__msg__FRIState__Sequence__are_equal(const kuka_driver_interfaces__msg__FRIState__Sequence * lhs, const kuka_driver_interfaces__msg__FRIState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kuka_driver_interfaces__msg__FRIState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kuka_driver_interfaces__msg__FRIState__Sequence__copy(
  const kuka_driver_interfaces__msg__FRIState__Sequence * input,
  kuka_driver_interfaces__msg__FRIState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kuka_driver_interfaces__msg__FRIState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kuka_driver_interfaces__msg__FRIState * data =
      (kuka_driver_interfaces__msg__FRIState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kuka_driver_interfaces__msg__FRIState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kuka_driver_interfaces__msg__FRIState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kuka_driver_interfaces__msg__FRIState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
