// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__FUNCTIONS_H_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "kuka_driver_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "kuka_driver_interfaces/msg/detail/fri_state__struct.h"

/// Initialize msg/FRIState message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * kuka_driver_interfaces__msg__FRIState
 * )) before or use
 * kuka_driver_interfaces__msg__FRIState__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__init(kuka_driver_interfaces__msg__FRIState * msg);

/// Finalize msg/FRIState message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
void
kuka_driver_interfaces__msg__FRIState__fini(kuka_driver_interfaces__msg__FRIState * msg);

/// Create msg/FRIState message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * kuka_driver_interfaces__msg__FRIState__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
kuka_driver_interfaces__msg__FRIState *
kuka_driver_interfaces__msg__FRIState__create();

/// Destroy msg/FRIState message.
/**
 * It calls
 * kuka_driver_interfaces__msg__FRIState__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
void
kuka_driver_interfaces__msg__FRIState__destroy(kuka_driver_interfaces__msg__FRIState * msg);

/// Check for msg/FRIState message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__are_equal(const kuka_driver_interfaces__msg__FRIState * lhs, const kuka_driver_interfaces__msg__FRIState * rhs);

/// Copy a msg/FRIState message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__copy(
  const kuka_driver_interfaces__msg__FRIState * input,
  kuka_driver_interfaces__msg__FRIState * output);

/// Initialize array of msg/FRIState messages.
/**
 * It allocates the memory for the number of elements and calls
 * kuka_driver_interfaces__msg__FRIState__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__Sequence__init(kuka_driver_interfaces__msg__FRIState__Sequence * array, size_t size);

/// Finalize array of msg/FRIState messages.
/**
 * It calls
 * kuka_driver_interfaces__msg__FRIState__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
void
kuka_driver_interfaces__msg__FRIState__Sequence__fini(kuka_driver_interfaces__msg__FRIState__Sequence * array);

/// Create array of msg/FRIState messages.
/**
 * It allocates the memory for the array and calls
 * kuka_driver_interfaces__msg__FRIState__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
kuka_driver_interfaces__msg__FRIState__Sequence *
kuka_driver_interfaces__msg__FRIState__Sequence__create(size_t size);

/// Destroy array of msg/FRIState messages.
/**
 * It calls
 * kuka_driver_interfaces__msg__FRIState__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
void
kuka_driver_interfaces__msg__FRIState__Sequence__destroy(kuka_driver_interfaces__msg__FRIState__Sequence * array);

/// Check for msg/FRIState message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__Sequence__are_equal(const kuka_driver_interfaces__msg__FRIState__Sequence * lhs, const kuka_driver_interfaces__msg__FRIState__Sequence * rhs);

/// Copy an array of msg/FRIState messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_kuka_driver_interfaces
bool
kuka_driver_interfaces__msg__FRIState__Sequence__copy(
  const kuka_driver_interfaces__msg__FRIState__Sequence * input,
  kuka_driver_interfaces__msg__FRIState__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__FUNCTIONS_H_
