// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kuka_driver_interfaces:msg/FriConfiguration.idl
// generated code does not contain a copyright notice
#include "kuka_driver_interfaces/msg/detail/fri_configuration__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
kuka_driver_interfaces__msg__FriConfiguration__init(kuka_driver_interfaces__msg__FriConfiguration * msg)
{
  if (!msg) {
    return false;
  }
  // receive_multiplier
  // send_period_ms
  return true;
}

void
kuka_driver_interfaces__msg__FriConfiguration__fini(kuka_driver_interfaces__msg__FriConfiguration * msg)
{
  if (!msg) {
    return;
  }
  // receive_multiplier
  // send_period_ms
}

bool
kuka_driver_interfaces__msg__FriConfiguration__are_equal(const kuka_driver_interfaces__msg__FriConfiguration * lhs, const kuka_driver_interfaces__msg__FriConfiguration * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // receive_multiplier
  if (lhs->receive_multiplier != rhs->receive_multiplier) {
    return false;
  }
  // send_period_ms
  if (lhs->send_period_ms != rhs->send_period_ms) {
    return false;
  }
  return true;
}

bool
kuka_driver_interfaces__msg__FriConfiguration__copy(
  const kuka_driver_interfaces__msg__FriConfiguration * input,
  kuka_driver_interfaces__msg__FriConfiguration * output)
{
  if (!input || !output) {
    return false;
  }
  // receive_multiplier
  output->receive_multiplier = input->receive_multiplier;
  // send_period_ms
  output->send_period_ms = input->send_period_ms;
  return true;
}

kuka_driver_interfaces__msg__FriConfiguration *
kuka_driver_interfaces__msg__FriConfiguration__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FriConfiguration * msg = (kuka_driver_interfaces__msg__FriConfiguration *)allocator.allocate(sizeof(kuka_driver_interfaces__msg__FriConfiguration), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kuka_driver_interfaces__msg__FriConfiguration));
  bool success = kuka_driver_interfaces__msg__FriConfiguration__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kuka_driver_interfaces__msg__FriConfiguration__destroy(kuka_driver_interfaces__msg__FriConfiguration * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kuka_driver_interfaces__msg__FriConfiguration__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kuka_driver_interfaces__msg__FriConfiguration__Sequence__init(kuka_driver_interfaces__msg__FriConfiguration__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FriConfiguration * data = NULL;

  if (size) {
    data = (kuka_driver_interfaces__msg__FriConfiguration *)allocator.zero_allocate(size, sizeof(kuka_driver_interfaces__msg__FriConfiguration), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kuka_driver_interfaces__msg__FriConfiguration__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kuka_driver_interfaces__msg__FriConfiguration__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kuka_driver_interfaces__msg__FriConfiguration__Sequence__fini(kuka_driver_interfaces__msg__FriConfiguration__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kuka_driver_interfaces__msg__FriConfiguration__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kuka_driver_interfaces__msg__FriConfiguration__Sequence *
kuka_driver_interfaces__msg__FriConfiguration__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kuka_driver_interfaces__msg__FriConfiguration__Sequence * array = (kuka_driver_interfaces__msg__FriConfiguration__Sequence *)allocator.allocate(sizeof(kuka_driver_interfaces__msg__FriConfiguration__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kuka_driver_interfaces__msg__FriConfiguration__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kuka_driver_interfaces__msg__FriConfiguration__Sequence__destroy(kuka_driver_interfaces__msg__FriConfiguration__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kuka_driver_interfaces__msg__FriConfiguration__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kuka_driver_interfaces__msg__FriConfiguration__Sequence__are_equal(const kuka_driver_interfaces__msg__FriConfiguration__Sequence * lhs, const kuka_driver_interfaces__msg__FriConfiguration__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kuka_driver_interfaces__msg__FriConfiguration__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kuka_driver_interfaces__msg__FriConfiguration__Sequence__copy(
  const kuka_driver_interfaces__msg__FriConfiguration__Sequence * input,
  kuka_driver_interfaces__msg__FriConfiguration__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kuka_driver_interfaces__msg__FriConfiguration);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kuka_driver_interfaces__msg__FriConfiguration * data =
      (kuka_driver_interfaces__msg__FriConfiguration *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kuka_driver_interfaces__msg__FriConfiguration__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kuka_driver_interfaces__msg__FriConfiguration__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kuka_driver_interfaces__msg__FriConfiguration__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
