// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kuka_driver_interfaces:msg/FriConfiguration.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__STRUCT_HPP_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kuka_driver_interfaces__msg__FriConfiguration __attribute__((deprecated))
#else
# define DEPRECATED__kuka_driver_interfaces__msg__FriConfiguration __declspec(deprecated)
#endif

namespace kuka_driver_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FriConfiguration_
{
  using Type = FriConfiguration_<ContainerAllocator>;

  explicit FriConfiguration_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->receive_multiplier = 0l;
      this->send_period_ms = 0l;
    }
  }

  explicit FriConfiguration_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->receive_multiplier = 0l;
      this->send_period_ms = 0l;
    }
  }

  // field types and members
  using _receive_multiplier_type =
    int32_t;
  _receive_multiplier_type receive_multiplier;
  using _send_period_ms_type =
    int32_t;
  _send_period_ms_type send_period_ms;

  // setters for named parameter idiom
  Type & set__receive_multiplier(
    const int32_t & _arg)
  {
    this->receive_multiplier = _arg;
    return *this;
  }
  Type & set__send_period_ms(
    const int32_t & _arg)
  {
    this->send_period_ms = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> *;
  using ConstRawPtr =
    const kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kuka_driver_interfaces__msg__FriConfiguration
    std::shared_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kuka_driver_interfaces__msg__FriConfiguration
    std::shared_ptr<kuka_driver_interfaces::msg::FriConfiguration_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FriConfiguration_ & other) const
  {
    if (this->receive_multiplier != other.receive_multiplier) {
      return false;
    }
    if (this->send_period_ms != other.send_period_ms) {
      return false;
    }
    return true;
  }
  bool operator!=(const FriConfiguration_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FriConfiguration_

// alias to use template instance with default allocator
using FriConfiguration =
  kuka_driver_interfaces::msg::FriConfiguration_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kuka_driver_interfaces

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_CONFIGURATION__STRUCT_HPP_
