// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_HPP_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kuka_driver_interfaces__msg__FRIState __attribute__((deprecated))
#else
# define DEPRECATED__kuka_driver_interfaces__msg__FRIState __declspec(deprecated)
#endif

namespace kuka_driver_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FRIState_
{
  using Type = FRIState_<ContainerAllocator>;

  explicit FRIState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->session_state = 0l;
      this->connection_quality = 0l;
      this->safety_state = 0l;
      this->command_mode = 0l;
      this->control_mode = 0l;
      this->operation_mode = 0l;
      this->drive_state = 0l;
      this->overlay_type = 0l;
      this->tracking_performance = 0.0;
    }
  }

  explicit FRIState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->session_state = 0l;
      this->connection_quality = 0l;
      this->safety_state = 0l;
      this->command_mode = 0l;
      this->control_mode = 0l;
      this->operation_mode = 0l;
      this->drive_state = 0l;
      this->overlay_type = 0l;
      this->tracking_performance = 0.0;
    }
  }

  // field types and members
  using _session_state_type =
    int32_t;
  _session_state_type session_state;
  using _connection_quality_type =
    int32_t;
  _connection_quality_type connection_quality;
  using _safety_state_type =
    int32_t;
  _safety_state_type safety_state;
  using _command_mode_type =
    int32_t;
  _command_mode_type command_mode;
  using _control_mode_type =
    int32_t;
  _control_mode_type control_mode;
  using _operation_mode_type =
    int32_t;
  _operation_mode_type operation_mode;
  using _drive_state_type =
    int32_t;
  _drive_state_type drive_state;
  using _overlay_type_type =
    int32_t;
  _overlay_type_type overlay_type;
  using _tracking_performance_type =
    double;
  _tracking_performance_type tracking_performance;

  // setters for named parameter idiom
  Type & set__session_state(
    const int32_t & _arg)
  {
    this->session_state = _arg;
    return *this;
  }
  Type & set__connection_quality(
    const int32_t & _arg)
  {
    this->connection_quality = _arg;
    return *this;
  }
  Type & set__safety_state(
    const int32_t & _arg)
  {
    this->safety_state = _arg;
    return *this;
  }
  Type & set__command_mode(
    const int32_t & _arg)
  {
    this->command_mode = _arg;
    return *this;
  }
  Type & set__control_mode(
    const int32_t & _arg)
  {
    this->control_mode = _arg;
    return *this;
  }
  Type & set__operation_mode(
    const int32_t & _arg)
  {
    this->operation_mode = _arg;
    return *this;
  }
  Type & set__drive_state(
    const int32_t & _arg)
  {
    this->drive_state = _arg;
    return *this;
  }
  Type & set__overlay_type(
    const int32_t & _arg)
  {
    this->overlay_type = _arg;
    return *this;
  }
  Type & set__tracking_performance(
    const double & _arg)
  {
    this->tracking_performance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> *;
  using ConstRawPtr =
    const kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kuka_driver_interfaces__msg__FRIState
    std::shared_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kuka_driver_interfaces__msg__FRIState
    std::shared_ptr<kuka_driver_interfaces::msg::FRIState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FRIState_ & other) const
  {
    if (this->session_state != other.session_state) {
      return false;
    }
    if (this->connection_quality != other.connection_quality) {
      return false;
    }
    if (this->safety_state != other.safety_state) {
      return false;
    }
    if (this->command_mode != other.command_mode) {
      return false;
    }
    if (this->control_mode != other.control_mode) {
      return false;
    }
    if (this->operation_mode != other.operation_mode) {
      return false;
    }
    if (this->drive_state != other.drive_state) {
      return false;
    }
    if (this->overlay_type != other.overlay_type) {
      return false;
    }
    if (this->tracking_performance != other.tracking_performance) {
      return false;
    }
    return true;
  }
  bool operator!=(const FRIState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FRIState_

// alias to use template instance with default allocator
using FRIState =
  kuka_driver_interfaces::msg::FRIState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kuka_driver_interfaces

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__STRUCT_HPP_
