// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kuka_driver_interfaces:msg/FRIState.idl
// generated code does not contain a copyright notice

#ifndef KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__TRAITS_HPP_
#define KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kuka_driver_interfaces/msg/detail/fri_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kuka_driver_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const FRIState & msg,
  std::ostream & out)
{
  out << "{";
  // member: session_state
  {
    out << "session_state: ";
    rosidl_generator_traits::value_to_yaml(msg.session_state, out);
    out << ", ";
  }

  // member: connection_quality
  {
    out << "connection_quality: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_quality, out);
    out << ", ";
  }

  // member: safety_state
  {
    out << "safety_state: ";
    rosidl_generator_traits::value_to_yaml(msg.safety_state, out);
    out << ", ";
  }

  // member: command_mode
  {
    out << "command_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.command_mode, out);
    out << ", ";
  }

  // member: control_mode
  {
    out << "control_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.control_mode, out);
    out << ", ";
  }

  // member: operation_mode
  {
    out << "operation_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.operation_mode, out);
    out << ", ";
  }

  // member: drive_state
  {
    out << "drive_state: ";
    rosidl_generator_traits::value_to_yaml(msg.drive_state, out);
    out << ", ";
  }

  // member: overlay_type
  {
    out << "overlay_type: ";
    rosidl_generator_traits::value_to_yaml(msg.overlay_type, out);
    out << ", ";
  }

  // member: tracking_performance
  {
    out << "tracking_performance: ";
    rosidl_generator_traits::value_to_yaml(msg.tracking_performance, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FRIState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: session_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "session_state: ";
    rosidl_generator_traits::value_to_yaml(msg.session_state, out);
    out << "\n";
  }

  // member: connection_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_quality: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_quality, out);
    out << "\n";
  }

  // member: safety_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safety_state: ";
    rosidl_generator_traits::value_to_yaml(msg.safety_state, out);
    out << "\n";
  }

  // member: command_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.command_mode, out);
    out << "\n";
  }

  // member: control_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "control_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.control_mode, out);
    out << "\n";
  }

  // member: operation_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "operation_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.operation_mode, out);
    out << "\n";
  }

  // member: drive_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "drive_state: ";
    rosidl_generator_traits::value_to_yaml(msg.drive_state, out);
    out << "\n";
  }

  // member: overlay_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overlay_type: ";
    rosidl_generator_traits::value_to_yaml(msg.overlay_type, out);
    out << "\n";
  }

  // member: tracking_performance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tracking_performance: ";
    rosidl_generator_traits::value_to_yaml(msg.tracking_performance, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FRIState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kuka_driver_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kuka_driver_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kuka_driver_interfaces::msg::FRIState & msg,
  std::ostream & out, size_t indentation = 0)
{
  kuka_driver_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kuka_driver_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kuka_driver_interfaces::msg::FRIState & msg)
{
  return kuka_driver_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kuka_driver_interfaces::msg::FRIState>()
{
  return "kuka_driver_interfaces::msg::FRIState";
}

template<>
inline const char * name<kuka_driver_interfaces::msg::FRIState>()
{
  return "kuka_driver_interfaces/msg/FRIState";
}

template<>
struct has_fixed_size<kuka_driver_interfaces::msg::FRIState>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kuka_driver_interfaces::msg::FRIState>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kuka_driver_interfaces::msg::FRIState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KUKA_DRIVER_INTERFACES__MSG__DETAIL__FRI_STATE__TRAITS_HPP_
